unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    FindDialog1: TFindDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}



procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    RichEdit1.Lines.LoadFromFile(OpenDialog1.FileName);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  FindDialog1.Execute;
end;

procedure TForm1.FindDialog1Find(Sender: TObject);
var
  FoundAt,nStartPos,nToEnd:Integer;
  search:Integer;
  searchType:TSearchTypes;
begin
  if frMatchCase in FindDialog1.Options then
    searchType := searchType + [stMatchCase];
  if frWholeWord in FindDialog1.Options then
    searchType := searchType + [stWholeWord];

  if RichEdit1.SelLength > 0 then
    nStartPos:=RichEdit1.SelStart+RichEdit1.SelLength
  else
    nStartPos:=0;
  nToEnd:=Length(RichEdit1.Text) - nStartPos;
  if frDown in FindDialog1.Options then
    FoundAt:=RichEdit1.FindText(FindDialog1.FindText,
     nStartPos ,nToEnd, searchType)
  else
  begin
    search:= -1 ;
    repeat
      FoundAt:= search ;
      search := RichEdit1.FindText(FindDialog1.FindText,
        search+1,RichEdit1.SelStart-search-1, searchType);
    until search<0 ;
  end;
  if ( FoundAt<>-1 ) then
  begin
    RichEdit1.SetFocus;
    RichEdit1.SelStart:= FoundAt;
    RichEdit1.SelLength:=Length(FindDialog1.FindText);
    RichEdit1.Perform(EM_SCROLLCARET, 0, 0);
  end
  else
    ShowMessage('䤣'+FindDialog1.FindText + 'r!');

end;

end.
